/**
 * Copyright (C) 2010 Technische Universität Dresden
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Dresden, University of Technology, Faculty of Computer Science
 * Computer Networks Group: http://www.rn.inf.tu-dresden.de
 * mobilis project: http://mobilisplatform.sourceforge.net
 */

package de.tudresden.inf.rn.mobilis.xmpp.beans;

/**
 * @author Benjamin Söllner
 */
public class XMPPUtil {

	private XMPPUtil() {}
	
	public static boolean isFullyQualified(String jid) {
		return !XMPPUtil.jidWithoutRessource(jid).equals(jid);
	}
	
	public static boolean similarJid(String first, String second) {
		String firstTrimmed  = XMPPUtil.jidWithoutRessource(first);
		String secondTrimmed = XMPPUtil.jidWithoutRessource(second);
		return firstTrimmed.equals(secondTrimmed);
	}
	
	public static String jidWithoutRessource(String jid) {
		int slashIndex = jid.indexOf('/');
		if (slashIndex == -1)
			return jid;
		else
			return jid.substring(0, slashIndex);
	}
	
}
